C       Hueckel M.O. calculation
C       I/P data: Name(17A4); Order, No. of pi electrons (2I3);
C         Energy matrix elements (lower diagonal) (20F5.0).
C       Program accepts any no. of data sets.
C
	DIMENSION A(20,20),C(20,20),AV(400),CV(400),E(20),P(20,20)
	INTEGER NAME(17)
C
C       I/O Statements
C
	JKL = 900
	OPEN(UNIT=10, FILE='HKLNEW.DAT')
	OPEN(UNIT=11, STATUS='UNKNOWN',FILE='HKLNEW.OUT')
	WRITE(11,*) JKL  
C        CALL SOPEN(10,1,' INPUT FILE? ... $')
C        CALL SOPEN(11,1,' OUTPUT TO ... ? $')
C
C       READ title, order (N), no. of electrons (NE) and write them
	WRITE(11,*)JKL
3       READ(10,1080,END=100)NAME
	READ(10,1050)N,NE
	IF(N.EQ.0)GOTO 100
	WRITE(11,1100)NAME
	WRITE(11,1090)N,NE
C
C       READ lower hamiltonian matrix A
	WRITE(11,1010)
	DO 10 I=1,N
	READ(10,1000)(A(I,J),J=1,I)
10      WRITE(11,1140)(A(I,J),J=1,I)
C
C       Convert matrix A into vector form and diagonalize with EIGEN
	CALL MATVEC(A,AV,N,1)
	CALL EIGEN(AV,CV,N,0)
C
C       Extract energy E-vals & E-vects and write the E-vals
	DO 20 I=1,N
	J=I*(I+1)/2
20      E(I)=-AV(J)
	WRITE(11,1030)
	WRITE(11,1020)(E(I),I=1,N)
C
C       Calculate the total energy by doubling the energies of each
C       occd. MO, making provision for a possible singly-occupied MO
	ND=NE/2
	ND2=2*ND
	ET=0
	DO 21 I=1,ND
21      ET=ET+2*E(I)
	IF(NE.LE.ND2)GO TO 23
22      N1=ND+1
	ET=ET+E(N1)
23      WRITE(11,1070)ET
C
C       Write the E-vectors (LCAO coeffts)
	WRITE(11,1040)
C       N2=N*N
C       WRITE(11,1020)(CV(I),I=1,N2)
C       WRITE(11,1160)
	CALL MATVEC(C,CV,N,4)
	DO 30 I=1,N
30      WRITE(11,1020)(C(I,J),J=1,N)
	DO 40 I=1,N
	DO 40 J=1,N
	P(I,J)=0.0
	DO 40 K=1,ND
40      P(I,J)=P(I,J)+C(K,I)*C(K,J)*2.0
	IF(NE.LE.ND2)GO TO 80
50      DO 60 I=1,N
	DO 60 J=1,N
60      P(I,J)=P(I,J)+C(N1,I)*C(N1,J)
80      CONTINUE
C
C       Supress elements of P which do not correspond to 
C       nearest neighbours
	DO 85 I=1,N
	A(I,I)=1.0
	DO 85 J=1,N
	IF(ABS(P(I,J)).LT.0.0001)P(I,J)=0.0
	IF(ABS(A(I,J)).LT.0.0001)A(I,J)=0.0
	IF(ABS(A(I,J)).GT.0.0001)A(I,J)=1.0
85      P(I,J)=P(I,J)*A(I,J)
	EL=0.0
C
C       Write density matrix and the sum of the diagonal elements
C       (total no. of pi electrons)
	WRITE(11,1060)
	DO 90 I=1,N
	WRITE(11,1020)(P(I,J),J=1,I)
90      EL=EL+P(I,I)
	WRITE(11,1150)EL
	WRITE(11,1110)NAME
	GO TO 3
100     WRITE(11,1120)
C
1000    FORMAT(20F5.0)
1010    FORMAT('0INPUT ENERGY MATRIX')
1020    FORMAT(1X,16F8.4)
1030    FORMAT('0ENERGY EIGENVALUES')
1040    FORMAT('0EIGENVECTOR MATRIX (LCAO COEFFICIENTS - ',
     1  'IN ROWS, IN ORDER OF INCREASING ENERGY)')
1050    FORMAT(10I3)
1060    FORMAT('0BOND  ORDER / ELECTRON POPULATION MATRIX')
1070    FORMAT('0TOTAL ENERGY =', F12.6)
1080    FORMAT(17A4)
1090    FORMAT('0ORDER =',I2,';    NO.OF ELECTS =',I2)
1100    FORMAT('1',/,1X,'HUECKEL CALCULATION ON' ,17A4)
1110    FORMAT('0END OF ',17A4)
1120    FORMAT(///5X,21HTHAT'S YER LOT, MATE!)
1140    FORMAT(1X,22F6.2)
1150    FORMAT('0SUM OF DIAGONAL ELEMENTS (NO OF PI ELECTRONS) =',F10.6)
1160    FORMAT(/)
C
	STOP
	END
C
C
      SUBROUTINE MATVEC(A,AV,N,M)
C   IF M=1 A LOWER-DIAG. MATRIX IS CONVERTED TO A VECTOR AV
C   IF M=2 A   SQUARE    MATRIX IS CONVERTED TO A VECTOR AV
C   IF M=3 A VECTOR AV IS CONVERTED TO A LOWER DIAGONAL MATRIX A
C   IF M=4 A VECTOR AV IS CONVERTED TO A SQUARE MATRIX A
C   Any other m value causes program to fail.
C
      DIMENSION A(20,20),AV(400)
C
      WRITE(11,*)N
      K=0
      IF(M.NE.1)GO TO 30
      DO 20 I=1,N
      DO 20 J=1,I
      K=K+1
20    AV(K)=A(I,J)
      GOTO 900
30    IF(M.NE.2)GO TO 50
      DO 40 I=1,N
      DO 40 J=1,N
      K=K+1
40    AV(K)=A(I,J)
      GOTO 900
50    IF(M.NE.3)GOTO 70
      DO 60 I=1,N
      DO 60 J=1,I
      K=K+1
60    A(I,J)=AV(K)
      GOTO 900
70    IF(M.NE.4)GOTO 90
      DO 80 I=1,N
      DO 80 J=1,N
      K=K+1
80    A(I,J)=AV(K)
      GO TO 900
90    WRITE(11,2000)M
2000  FORMAT(/,' M =',I3,'  :   SHOULD BE BETWEEN 1 AND 4')
      STOP
900   RETURN
      END
C
C
C
      SUBROUTINE EIGEN(A,R,N,MV)
      DIMENSION R(400),A(400)
    5 RANGE=1.0E-6
      IF(MV-1) 10,25,10
   10 IQ=-N
      DO 20 J=1,N
      IQ=IQ+N
      DO 20 I=1,N
      IJ=IQ+I
      R(IJ)=0.0
      IF(I-J) 20,15,20
   15 R(IJ)=1.0
   20 CONTINUE
   25 ANORM=0.0
      DO 35 I=1,N
      DO 35 J=I,N
      IF(I-J) 30,35,30
   30 IA=I+(J*J-J)/2
      ANORM=ANORM+A(IA)*A(IA)
   35 CONTINUE
      IF(ANORM) 165,165,40
   40 ANORM=1.414*SQRT(ANORM)
      ANRMX=ANORM*RANGE/FLOAT(N)
      IND=0
      THR=ANORM
   45 THR=THR/FLOAT(N)
   50 L=1
   55 M=L+1
   60 MQ=(M*M-M)/2
      LQ=(L*L-L)/2
      LM=L+MQ
   62 IF( ABS(A(LM))-THR) 130,65,65
   65 IND=1
      LL=L+LQ
      MM=M+MQ
      X=0.5*(A(LL)-A(MM))
   68 Y=-A(LM)/ SQRT(A(LM)*A(LM)+X*X)
      IF(X) 70,75,75
   70 Y=-Y
   75 SINX=Y/ SQRT(2.0*(1.0+( SQRT(1.0-Y*Y))))
      SINX2=SINX*SINX
   78 COSX= SQRT(1.0-SINX2)
      COSX2=COSX*COSX
      SINCS =SINX*COSX
      ILQ=N*(L-1)
      IMQ=N*(M-1)
      DO 125 I=1,N
      IQ=(I*I-I)/2
      IF(I-L) 80,115,80
   80 IF(I-M) 85,115,90
   85 IM=I+MQ
      GO TO 95
   90 IM=M+IQ
   95 IF(I-L) 100,105,105
  100 IL=I+LQ
      GO TO 110
  105 IL=L+IQ
  110 X=A(IL)*COSX-A(IM)*SINX
      A(IM)=A(IL)*SINX+A(IM)*COSX
      A(IL)=X
  115 IF(MV-1) 120,125,120
  120 ILR=ILQ+I
      IMR=IMQ+I
      X=R(ILR)*COSX-R(IMR)*SINX
      R(IMR)=R(ILR)*SINX+R(IMR)*COSX
      R(ILR)=X
  125 CONTINUE
      X=2.0*A(LM)*SINCS
      Y=A(LL)*COSX2+A(MM)*SINX2-X
      X=A(LL)*SINX2+A(MM)*COSX2+X
      A(LM)=(A(LL)-A(MM))*SINCS+A(LM)*(COSX2-SINX2)
      A(LL)=Y
      A(MM)=X
  130 IF(M-N) 135,140,135
  135 M=M+1
      GO TO 60
  140 IF(L-(N-1)) 145,150,145
  145 L=L+1
      GO TO 55
  150 IF(IND-1) 160,155,160
  155 IND=0
      GO TO 50
  160 IF(THR-ANRMX) 165,165,45
  165 IQ=-N
      DO 185 I=1,N
      IQ=IQ+N
      LL=I+(I*I-I)/2
      JQ=N*(I-2)
      DO 185 J=I,N
      JQ=JQ+N
      MM=J+(J*J-J)/2
      IF(A(LL)-A(MM)) 170,185,185
  170 X=A(LL)
      A(LL)=A(MM)
      A(MM)=X
      IF(MV-1) 175,185,175
  175 DO 180 K=1,N
      ILR=IQ+K
      IMR=JQ+K
      X=R(ILR)
      R(ILR)=R(IMR)
  180 R(IMR)=X
  185 CONTINUE
      RETURN
      END
c/add name = sOPEN
c      This subroutine accepts a filename for a file
c      and OPENs it, assigning it a certain specified Fortran logical 
c      unit number. It assumes that the file to be OPENs exists (except
c      temporary files).
c      The unit number, the text to be displayed 
c      when asking for the filename and the type of file to be OPENed
c      are passed in as parameters.
c
c      iunitno=unit number to be assugned; inputprompt= text to 
c      be displayed; filestatus = type of file to be OPENed
c
c
       SUBROUTINE SOPEN(UNITNO,filestat,inputprompt)
       integer unitno,filestat
       character*(*) inputprompt
       character*39 filename
c write 'filename' prompt..
       write (6,997)inputprompt
  997  format(a30,': ',$)
       READ(5,998)filename
  998  format(a39)
c test filestat: if=1 then file is permanent, =2 then scratch (temporary)
	  if (filestat .eq. 1) then     
	  OPEN (unit=UNITNO, file=filename,status='UNKNOWN')
	       else
	     if (filestat .eq. 2) then
	     OPEN (unit=unitno,file=filename,status='UNKNOWN')
	     endif
	  endif

       end
c-----
